LongProperty (JavaFX 19)
Description: declaration: module: javafx.base, package: javafx.beans.property, class: LongProperty

Module javafx.base
Package javafx.beans.property

# Class LongProperty

java.lang.Object
javafx.beans.binding.NumberExpressionBase
javafx.beans.binding.LongExpression
javafx.beans.property.ReadOnlyLongProperty
javafx.beans.property.LongProperty

All Implemented Interfaces:
  `NumberExpression`, `Observable`, `Property<Number>`, `ReadOnlyProperty<Number>`, `ObservableLongValue`, `ObservableNumberValue`, `ObservableValue<Number>`, `WritableLongValue`, `WritableNumberValue`, `WritableValue<Number>`

Direct Known Subclasses:
  `JavaBeanLongProperty`, `LongPropertyBase`

public abstract class LongProperty extends ReadOnlyLongProperty implements Property<Number>, WritableLongValue
This class defines a `Property` wrapping a `long` value.

The value of a `LongProperty` can be get and set with `ObservableLongValue.get()`, `LongExpression.getValue()`, `WritableLongValue.set(long)`, and `setValue(Number)`.

A property can be bound and unbound unidirectional with `Property.bind(ObservableValue)` and `Property.unbind()`. Bidirectional bindings can be created and removed with `bindBidirectional(Property)` and `unbindBidirectional(Property)`.

The context of a `LongProperty` can be read with `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()`.

Note: setting or binding this property to a null value will set the property to "0.0". See `setValue(java.lang.Number)`.

Since:
  JavaFX 2.0
See Also:
  - `ObservableLongValue`
  - `WritableLongValue`
  - `ReadOnlyLongProperty`
  - `Property`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LongProperty()`
  Creates a default `LongProperty`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ObjectProperty<Long>`
  `asObject()`
  Creates an `ObjectProperty` that bidirectionally bound to this `LongProperty`.
  `void`
  `bindBidirectional(Property<Number> other)`
  Create a bidirectional binding between this `Property` and another one.
  `static LongProperty`
  `longProperty(Property<Long> property)`
  Returns a `LongProperty` that wraps a `Property` and is bidirectionally bound to it.
  `void`
  `setValue(Number v)`
  Set the wrapped value.
  `String`
  `toString()`
  Returns a string representation of this `LongProperty` object.
  `void`
  `unbindBidirectional(Property<Number> other)`
  Removes a bidirectional binding between this `Property` and another one.

  ### Methods declared in class javafx.beans.property.ReadOnlyLongProperty

  `readOnlyLongProperty`

  ### Methods declared in class javafx.beans.binding.LongExpression

  `add, add, add, add, divide, divide, divide, divide, doubleValue, floatValue, getValue, intValue, longExpression, longExpression, longValue, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract`

  ### Methods declared in class javafx.beans.binding.NumberExpressionBase

  `add, asString, asString, asString, divide, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, multiply, numberExpression, subtract`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.beans.Observable

  `addListener, removeListener`

  ### Methods declared in interface javafx.beans.value.ObservableLongValue

  `get`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `addListener, flatMap, getValue, map, orElse, removeListener`

  ### Methods declared in interface javafx.beans.property.Property

  `bind, isBound, unbind`

  ### Methods declared in interface javafx.beans.property.ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface javafx.beans.value.WritableLongValue

  `get, set`

  ### Methods declared in interface javafx.beans.value.WritableValue

  `getValue`

- ## Constructor Details

  - ### LongProperty

    public LongProperty()
    Creates a default `LongProperty`.

- ## Method Details

  - ### setValue

    public void setValue(Number v)
    Set the wrapped value.
    Specified by:
      `setValue` in interface `WritableLongValue`
    Specified by:
      `setValue` in interface `WritableValue<Number>`
    Parameters:
      `v` - The new value

  - ### bindBidirectional

    public void bindBidirectional(Property<Number> other)
    Create a bidirectional binding between this `Property` and another one. Bidirectional bindings exists independently of unidirectional bindings. So it is possible to add unidirectional binding to a property with bidirectional binding and vice-versa. However, this practice is discouraged.

    It is possible to have multiple bidirectional bindings of one Property.

    JavaFX bidirectional binding implementation use weak listeners. This means bidirectional binding does not prevent properties from being garbage collected.

    Specified by:
      `bindBidirectional` in interface `Property<Number>`
    Parameters:
      `other` - the other `Property`

  - ### unbindBidirectional

    public void unbindBidirectional(Property<Number> other)
    Removes a bidirectional binding between this `Property` and another one. If no bidirectional binding between the properties exists, calling this method has no effect. It is possible to unbind by a call on the second property. This code will work:

    >          property1.bindBidirectional(property2);
    >          property2.unbindBidirectional(property1);

    Specified by:
      `unbindBidirectional` in interface `Property<Number>`
    Parameters:
      `other` - the other `Property`

  - ### toString

    public String toString()
    Returns a string representation of this `LongProperty` object.
    Overrides:
      `toString` in class `ReadOnlyLongProperty`
    Returns:
      a string representation of this `LongProperty` object.

  - ### longProperty

    public static LongProperty longProperty(Property<Long> property)
    Returns a `LongProperty` that wraps a `Property` and is bidirectionally bound to it. Changing this property will result in a change of the original property.

    This is very useful when bidirectionally binding an ObjectProperty<Long> and a LongProperty.

    >        LongProperty longProperty = new SimpleLongProperty(1L);
    >        ObjectProperty<Long> objectProperty = new SimpleObjectProperty<>(2L);

    >        // Need to keep the reference as bidirectional binding uses weak references
    >        LongProperty objectAsLong = LongProperty.longProperty(objectProperty);

    >        longProperty.bindBidirectional(objectAsLong);

    Another approach is to convert the LongProperty to ObjectProperty using `asObject()` method.

    Note: null values in the source property will be interpreted as 0L

    Parameters:
      `property` - The source `Property`
    Returns:
      A `LongProperty` that wraps the `Property`
    Throws:
      `NullPointerException` - if `property` is `null`
    Since:
      JavaFX 8.0
    See Also:
      - `asObject()`

  - ### asObject

    public ObjectProperty<Long> asObject()
    Creates an `ObjectProperty` that bidirectionally bound to this `LongProperty`. If the value of this `LongProperty` changes, the value of the `ObjectProperty` will be updated automatically and vice-versa.

    Can be used for binding an ObjectProperty to LongProperty.

    >        LongProperty longProperty = new SimpleLongProperty(1L);
    >        ObjectProperty<Long> objectProperty = new SimpleObjectProperty<>(2L);

    >        objectProperty.bind(longProperty.asObject());

    Overrides:
      `asObject` in class `ReadOnlyLongProperty`
    Returns:
      the new `ObjectProperty`
    Since:
      JavaFX 8.0